/** 
 * Substitute for xeventx
 * */

const EventualContext = require('./eventual-context');


class Eventual {
	constructor() {
		this._events = {
			ctx: [],
			state: {} 
		};
	}
	createContext() {
		var ret = new EventualContext(this);
		this._events.ctx.push(ret);
		return ret;
	}
	destroyContext(ctx) {
		var i = this._events.ctx.indexOf(ctx);
		if(i!=-1) this._events.ctx.splice(i,1);
	}
	state(name,args) {
		// Should do this per context
		this._events.state[name] = args;
	}
}

module.exports = Eventual;

